/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _HW4_SOCKETUTILS_H_
#define _HW4_SOCKETUTILS_H_

// This header file provides a set of useful utilities for reading
// and writing data over sockets.

namespace hw4 {

// This function uses the write() system call to attempt to write
// "bytes_to_write" bytes of data from "data" to the file descriptor
// "fd".  The function will re-attempt writes on EINTR, but will return
// if it encounters EAGAIN/EWOULDBLOCK.  The number of bytes actually
// written is returned via output parameter "bytes_written."
//
// The function returns:
//
// - true if the socket is still alive; this is the case if (a) data
//   was written, or (b) no data was written and EAGAIN/EWOULDBLOCK
//   was encountered.
//
// - false if the socket is no longer alive; this is the case if
//   no data was written and EOF was encountered, or if an error other
//   than EAGAIN/EWOULDBLOCK was enountered.  If false is returned,
//   the caller is responsible for closing the socket.
bool NBWrite(const int fd,
             const char *data,
             const unsigned int bytes_to_write,
             unsigned int *bytes_written);

// This function is similar to NBWrite, but it attempts to read data
// from fd instead of writing data to fd.  The return values (both
// through the output parameter bytes_read and the boolean return
// value) are identical to NBWrite.
bool NBRead(const int fd,
            char *data,
            const unsigned int bytes_to_read,
            unsigned int *bytes_read);

}  // namespace hw4

#endif  // _HW4_SOCKETUTILS_H_
